// textadventure library

// read line from file pointer
int readline(FILE *source, char line[])
{
 int i=0;
 char c;

   while ((c=fgetc(source))!='\n' && c!=EOF && source && i<MAXLINE-1)
    if ((i) || (!i && !isspace(c))) // discard starting spaces
     line[i++]=c;
    // purge ending spaces
    while (isspace(line[i-1]))
     --i;
   line[i]='\0';

 return strlen(line);
}

// replace underscores with spaces
char *replaceunderscores(char dataname[])
{
  int i1;
  
   for (i1=0;i1<strlen(dataname);i1++)
    if (dataname[i1]=='_')
     dataname[i1]=SPACE;
   dataname[i1]='\0';
   
 return &dataname[0];
}

// read room
int readroom(struct Menu *newroom)
{
  int roombracket=0, i, entriesread=0, entrycommand, entrydirectionid;
  char line[MAXLINE], entrydescription[MAXNAME];
  Menu *execroom=malloc(sizeof(Menu));
  MenuEntry *tmenuentries[MAXMENUENTRIES];
  MenuEntry *texecentry;
    
   // parse .dat file (further) down
   while ((i=readline(f, line))) {
    entrycommand=0;
    entrydirectionid=0;
    // automatic command line parser
    if (!roombracket && line[0]=='*') {
     linetomenuentry(line, entrydescription, &entrycommand, &entrydirectionid);
     texecentry=newMenuEntry(entrydescription, entrycommand, entrydirectionid);
     pushEntrytoMenu(execroom, texecentry);
     rooms[MAXROOMS]=execroom;
    executeroomcommand(MAXROOMS, execroom->menuEntriesSize-1); }
    // close room structure
    if (line[0]=='}' && roombracket) {
     ++roombracket;
    break; }
    // parse room structure
    if (entriesread && roombracket) {
     linetomenuentry(line, entrydescription, &entrycommand, &entrydirectionid);
     tmenuentries[entriesread-1]=newMenuEntry(entrydescription, entrycommand, entrydirectionid);
     if (newroom->menuEntriesSize<MAXMENUENTRIES) {
      pushEntrytoMenu(newroom, tmenuentries[entriesread-1]);
    ++entriesread; } }
    // room title
    if (!entriesread && roombracket) {
     strcpy(newroom->menuTitle, replaceunderscores(line));
    ++entriesread; }
    // open room structure
    if (line[0]=='{' && !roombracket)
   roombracket=1; }
   
   if (roombracket<2)
    return 0;
    
 return 1;
}

// text line to menu entry repair routine
void linetomenuentry(char line[], char entrydescription[], int *entrycommand, int *entrydirectionid)
{
  const char *separator=" ";
  char *token;
  
  token=strtok(line, separator);
  if (token!=NULL)
   strcpy(entrydescription, replaceunderscores(token));
  token=strtok(NULL, separator);
  if (token!=NULL)
   *entrycommand=parsestringforcommand(token);
  token=strtok(NULL, separator);
  if (token!=NULL)
   *entrydirectionid=atoi(token);
}

// descibe the room and choices
void describeroom(int room)
{
  int i1;
  
   printf("\n%s\n", rooms[room]->menuTitle);
   printf("your options:\n");
   for (i1=0;i1<rooms[room]->menuEntriesSize;i1++)
     printf("%c.%s\n", i1+97, rooms[room]->menuEntries[i1].entryText);
}

// parse string for parser command
int parsestringforcommand(char *line)
{
  int i, command;
  
   for (i=0;i<12;i++)
    if (!strcmp(line, PARSERCOMMANDS[i]))
     break;
   command=(i==12) ? atoi(line) : MAXROOMS+1+i;
     
 return command;
}

// command parser
int commandparser(int room, int choice)
{
  int command=rooms[room]->menuEntries[choice].returnCommand;  
    
  if (command<SETSUCCESS || command>SETSCOREINCREMENTATION)
   return 0;
    
  switch (command) {
   case SETSUCCESS:
    ++success;
   break;
   case SETFAILURE:
    ++failure;
   break;
   case RESTARTGAME:
    score=0;
    moves=0;
    currentroom=0;
   break;
   case ENDGAME:
    game=false;
   break;
   case ADDSCORE:
    if ((!maxscore) || (maxscore && score<maxscore))
     score+=scoreincrementation;
   break;
   case DEDUCTSCORE:
    if ((score-scoreincrementation)>-1)
    score-=scoreincrementation;
   break;
   case REPEATTEXTS:
    printf("%s\n", rooms[rooms[room]->menuEntries[choice].menuIdDirection]->menuTitle);
 // small trick
   break;
   case SETMAXMOVES:
    if (rooms[room]->menuEntries[choice].menuIdDirection>MAXMOVES)
     break; // limit
    maxmoves=rooms[room]->menuEntries[choice].menuIdDirection; // small trick
   break;
   case ENDGAMEONMAXMOVES:
    endgameonmaxmoves=(endgameonmaxmoves) ? false : true;
   break;
   case SETMAXSCORE:
    maxscore=rooms[room]->menuEntries[choice].menuIdDirection; // same as SETMAXMOVES
   break;
   case SETSCOREINCREMENTATION:
    scoreincrementation=rooms[room]->menuEntries[choice].menuIdDirection; // again
   break;
   case SETCURRENTROOM:
    currentroom=rooms[room]->menuEntries[choice].menuIdDirection;
  break; }
    
 return 1;   
}

// execute room command
int executeroomcommand(int room, int choice)
{
  int i, command=0, destination=0; 
  
  if (choice>=rooms[room]->menuEntriesSize)
   return 0;
  command=rooms[room]->menuEntries[choice].returnCommand;
  destination=rooms[room]->menuEntries[choice].menuIdDirection;
    
   if (command)
    if (!(i=commandparser(room, choice)))
     return 0;
   if (destination<roomsnumber && command<REPEATTEXTS)
    currentroom=destination;
    
 return 1;
}

