// textadventure library

// read line from keyboard
int readkbrdline(char line[])
{
  int i=0;
  char c;
  
   while ((c=getchar())!='\n' && i<MAXLINE)
    line[i++]=c;
   line[i]='\0'; 
    
 return strlen(line);
}

// read line from file
int readline(FILE *source, char line[])
{
 int i=0;
 char c;

   while ((c=fgetc(source))!='\n' && c!=EOF && source && i<MAXLINE) {
    line[i++]=c; }
   line[i]='\0';

 return strlen(line);
}

// replace underscores with spaces
char *replaceunderscores(char dataname[])
{
  int i1;
  
   for (i1=0;i1<strlen(dataname);i1++)
    if (dataname[i1]=='_')
     dataname[i1]=SPACE;
   dataname[i1]='\0';
   
 return &dataname[0];
}

// read room
int readroom(struct Menu *newroom)
{
  int roombracket=0, i, entriesread=0, entrycommand, entrydirectionid;
  const char *separator=" ";
  char line[MAXLINE], *token, entrydescription[MAXNAME];
  Menu *execroom=malloc(sizeof(Menu));
  MenuEntry *tmenuentries[MAXMENUENTRIES];
  MenuEntry *texecentry;
    
   // parse .dat file (further) down
   while ((i=readline(f, line))) {
    entrycommand=0;
    entrydirectionid=0;
    // automatic command line parser
    if (line[0]=='*' && !roombracket) {
     linetomenuentry(line, entrydescription, &entrycommand, &entrydirectionid);
//      token=strtok(line, separator);
//      token=strtok(NULL, separator);
//      entrycommand=parsestringforcommand(token);
//      token=strtok(NULL, separator);
//      entrydirectionid=atoi(token);
     texecentry=newMenuEntry(entrydescription, entrycommand, entrydirectionid);
     pushEntrytoMenu(execroom, texecentry);
     rooms[MAXROOMS]=execroom;
    executeroomcommand(MAXROOMS, execroom->menuEntriesSize-1); }
    if (line[0]=='}' && roombracket) {
     ++roombracket;
    break; }
    if (entriesread && roombracket) {
//      token=strtok(line, separator);
//      strcpy(entrydescription, replaceunderscores(token));
//      token=strtok(NULL, separator);
//      entrycommand=parsestringforcommand(token);
//      token=strtok(NULL, separator);
//      entrydirectionid=atoi(token);
     linetomenuentry(line, entrydescription, &entrycommand, &entrydirectionid);
     tmenuentries[entriesread-1]=newMenuEntry(entrydescription, entrycommand, entrydirectionid);
     pushEntrytoMenu(newroom, tmenuentries[entriesread-1]);
    ++entriesread; }
    if (!entriesread && roombracket) {
     strcpy(newroom->menuTitle, replaceunderscores(line));
    ++entriesread; }
    if (line[0]=='{' && !roombracket)
   roombracket=1; }
    
   if (roombracket<2)
    return 0;
    
 return 1;
}

// text line to menu entry repair routine
void linetomenuentry(char line[], char entrydescription[], int *entrycommand, int *entrydirectionid)
{
  const char *separator=" ";
  char *token;
  
  token=strtok(line, separator);
  strcpy(entrydescription, replaceunderscores(token));
  token=strtok(NULL, separator);
  *entrycommand=parsestringforcommand(token);
  token=strtok(NULL, separator);
  *entrydirectionid=atoi(token);
}

// descibe the room and choices
void describeroom(int room)
{
  int i1;
  
   printf("\n%s\n", rooms[room]->menuTitle);
   printf("your options:\n");
   for (i1=0;i1<rooms[room]->menuEntriesSize;i1++)
     printf("%c.%s\n", i1+97, rooms[room]->menuEntries[i1].entryText);
}

// parse string for parser command
int parsestringforcommand(char *line)
{
  int i, command;
  
   for (i=0;i<12;i++)
    if (!strcmp(line, PARSERCOMMANDS[i]))
     break;
   if (i==12)
    return atoi(line);
   
   switch (i) {
    case 0:
     command=SETSUCCESS;
    break;
    case 1:
     command=SETFAILURE;
    break;
    case 2:
     command=RESTARTGAME;
    break;
    case 3:
     command=ENDGAME;
    break;
    case 4:
     command=ADDSCORE;
    break;
    case 5:
     command=DEDUCTSCORE;
    break;
    case 6:
     command=REPEATTEXTS;
    case 7:
     command=SETMAXMOVES;
    break;
    case 8:
     command=ENDGAMEONMAXMOVES;
    break;
    case 9:
     command=SETMAXSCORE;
    break;
    case 10:
     command=SETSCOREINCREMENTATION;
    break;
    case 11:
     command=SETCURRENTROOM;
   break; }
     
 return command;
}


// command parser
int commandparser(int room, int choice)
{
  int command=rooms[room]->menuEntries[choice].returnCommand;  
    
  if (command<SETSUCCESS || command>SETSCOREINCREMENTATION)
   return 0;
    
  switch (command) {
   case SETSUCCESS:
    success=true;
   break;
   case SETFAILURE:
    failure=true;
   break;
   case RESTARTGAME:
    score=0;
    moves=0;
    currentroom=0;
   break;
   case ENDGAME:
    game=false;
   break;
   case ADDSCORE:
    score+=scoreincrementation;
   break;
   case DEDUCTSCORE:
    if ((score-scoreincrementation)>-1)
    score-=scoreincrementation;
   break;
   case REPEATTEXTS:
    describeroom(rooms[room]->menuEntries[choice].menuIdDirection); // small trick
   break;
   case SETMAXMOVES:
    if (rooms[room]->menuEntries[choice].menuIdDirection>MAXMOVES)
     break; // limit
    maxmoves=rooms[room]->menuEntries[choice].menuIdDirection; // small trick
   break;
   case ENDGAMEONMAXMOVES:
    endgameonmaxmoves=(endgameonmaxmoves) ? false : true;
   break;
   case SETMAXSCORE:
    maxscore=rooms[room]->menuEntries[choice].menuIdDirection; // same as SETMAXMOVES
   break;
   case SETSCOREINCREMENTATION:
    scoreincrementation=rooms[room]->menuEntries[choice].menuIdDirection; // again
   break;
   case SETCURRENTROOM:
    currentroom=rooms[room]->menuEntries[choice].menuIdDirection;
  break; }
    
 return 1;   
}

// execute room command
int executeroomcommand(int room, int choice)
{
  int i, command=0, destination=0; 
  
  command=rooms[room]->menuEntries[choice].returnCommand;
  destination=rooms[room]->menuEntries[choice].menuIdDirection;
    
   if (command)
    if (!(i=commandparser(room, choice)))
     return 0;
   if (destination<roomsnumber && command<SETMAXMOVES)
    currentroom=destination;
    
 return 1;
}
  
