// textadventure headers
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdbool.h>
#include <ctype.h>

// numerical definitions
#define MAXROOMS 10000
#define MAXMENUENTRIES 8
#define MAXNAME 80
#define MAXLINE 1850
#define SCOREINCREMENTATION 1
#define MAXMOVES 10000
#define SPACE 32
// numerical commands
#define SETSUCCESS MAXROOMS+1 // MAXROOMS coincides with max user commands
#define SETFAILURE MAXROOMS+2
#define RESTARTGAME MAXROOMS+3
#define ENDGAME MAXROOMS+4
#define ADDSCORE MAXROOMS+5
#define DEDUCTSCORE MAXROOMS+6
#define REPEATTEXTS MAXROOMS+7
// direct commands
#define SETMAXMOVES MAXROOMS+8
#define ENDGAMEONMAXMOVES MAXROOMS+9
#define SETMAXSCORE MAXROOMS+10
#define SETSCOREINCREMENTATION MAXROOMS+11
#define SETCURRENTROOM MAXROOMS+12
const char *PARSERCOMMANDS[]= { "SETSUCCESS", "SETFAILURE", "RESTARTGAME", "ENDGAME", "ADDSCORE", "DEDUCTSCORE", "REPEATTEXTS", "SETMAXMOVES", "ENDGAMEONMAXMOVES", "SETMAXSCORE", "SETSCOREINCREMENTATION", "SETCURRENTROOM" };

// type definitions
typedef struct MenuEntry {
 char entryText[MAXLINE];
 int returnCommand;
int menuIdDirection; } MenuEntry;
 
typedef struct Menu {
 int fatherMenuPosition;
 char menuTitle[MAXLINE];
 int menuEntriesSize;
struct MenuEntry menuEntries[MAXMENUENTRIES]; } Menu;

// global variables&constants
Menu *rooms[MAXROOMS+1];
FILE *f;
bool game=true, endgameonmaxmoves=false;
int success=0, failure=0, score=0, scoreincrementation=SCOREINCREMENTATION, maxscore=0, moves=0, roomsnumber=0, currentroom=0, maxmoves=MAXMOVES;

// functions definitions
// dynamicmenus.c
MenuEntry *newMenuEntry(char *text, int command, int iddirection);
int pushEntrytoMenu(Menu *targetmenu, struct MenuEntry *newentry);
// libtextadventure.c
int readline(FILE *source, char line[]);
char *replaceunderscores(char dataname[]);
int readroom(struct Menu *newroom);
void linetomenuentry(char line[], char entrydescription[], int *entrycommand, int *entrydirectionid);
void describeroom(int room);
int parsestringforcommand(char *line);
int commandparser(int room, int choice);
int executeroomcommand(int room, int choice);

// local libraries
#include "dynamicmenus.c"
#include "libtextadventure.c"
